
/*
 * KITNARF's Java Library <http://www.kitnarf.cz/java/>.
 * COPYRIGHT (C) 2009 Petr Frantík (www.kitnarf.cz). ALL RIGHTS RESERVED. 
 */


package cz.kitnarf.color;

import java.awt.*;


//**************************************************************************************************************************
/**
 *Bicircular color function. This function is composed from two segments of
 *circle. It has 1002 colors.
 *
 *@author Petr Frantík
 *@version 20130126
 */
public class BicircularColorFunction extends ColorFunction
{



	//*****************************************************************************************
	/** {@inheritDoc} */
	@Override
	public Color getColor(double cd)
	{
		double redd;
		int[] ci=new int[3];
		//
		//
		//uhel
		double ad=Math.PI*cd;
		//
		if(cd<=0.5)
		{
			ci[0]=(int)(Math.cos(ad)*255+0.999999999999);
			ci[1]=(int)(Math.sin(ad)*255);
			ci[2]=0;
		}
		else
		{
			ci[0]=0;
			ci[1]=(int)(Math.sin(ad)*255);
			ci[2]=(int)(-Math.cos(ad)*255+0.999999999999);
		}
		//
		return new Color(ci[0],ci[1],ci[2]);
	}

}
