
/*
 * KITNARF's Java Library <http://www.kitnarf.cz/java/>.
 * COPYRIGHT (C) 2009 Petr Frantík (www.kitnarf.cz). ALL RIGHTS RESERVED. 
 */


package cz.kitnarf.color;

import java.awt.*;


//**************************************************************************************************************************
/**
 *Bilinear color function. This function is composed from two straight segments.
 *It has 511 colors.
 *
 *@author Petr Frantík
 *@version 20130126
 */
public class BilinearColorFunction extends ColorFunction
{



	//*****************************************************************************************
	/** {@inheritDoc} */
	@Override
	public Color getColor(double cd)
	{
		int[] ci=new int[3];
		//
		//
		if(cd<=0.5)
		{
			ci[0]=(int)((0.5-cd)*510.999999999999+0.5);
			ci[1]=(int)(cd*511);
			ci[2]=0;
		}
		else
		{
			ci[0]=0;
			ci[1]=(int)((1.0-cd)*511);
			ci[2]=(int)((cd-0.5)*510.999999999999+0.5);
		}
		//
		return new Color(ci[0],ci[1],ci[2]);
	}

}
