
/*
 * KITNARF's Java Library <http://www.kitnarf.cz/java/>.
 * COPYRIGHT (C) 2009 Petr Frantík (www.kitnarf.cz). ALL RIGHTS RESERVED. 
 */


package cz.kitnarf.color;

import java.awt.Color;

/**
 *Class serving for resampling of a color function.
 *
 *@author Petr Frantík
 *@version 20130126
 */
public class ColorStepper extends ColorTransform
{
	/** Number of steps.*/
	protected int stepCount=6;




	/** {@inheritDoc} */
	@Override
	public double transform(double c)
	{
		int trunc=(int)(0.999999999999999*c*stepCount);
		return 1d*trunc/(stepCount-1);
	}
	/** {@inheritDoc} */
	@Override
	public double[] getBounds(){return new double[]{0d,1d};}




	/** Sets number of steps. */
	public void setStepCount(int stepCount){this.stepCount=stepCount;}
	/** Gets number of steps. */
	public int getStepCount(){return stepCount;}








}
