
/*
 * KITNARF's Java Library <http://www.kitnarf.cz/java/>.
 * COPYRIGHT (C) 2009 Petr Frantík (www.kitnarf.cz). ALL RIGHTS RESERVED. 
 */


package cz.kitnarf.color;

import java.awt.Color;

/**
 *Class which ensures transformation between a double value and a color from a color function.
 *
 *@author Petr Frantík
 *@version 20130126
 */
public abstract class ColorTransform extends ColorFunctionOwner
{




	/**Calculates tranformation of the independent variable.*/
	public double transform(double c){return c;}

	/**Gets bounds for this transform.*/
	public abstract double[] getBounds();




	/** {@inheritDoc} */
	@Override
	public Color getColor(double c){return function.getColor(transform(c));}
	/** {@inheritDoc} */
	@Override
	public Color getSafeColor(double c){return function.getSafeColor(transform(c));}





}
