
/*
 * KITNARF's Java Library <http://www.kitnarf.cz/java/>.
 * COPYRIGHT (C) 2009 Petr Frantík (www.kitnarf.cz). ALL RIGHTS RESERVED. 
 */


package cz.kitnarf.color;

import java.awt.Color;

/**
 *Class which ensures linear transformation between a double value and a color from a color function.
 *
 *@author Petr Frantík
 *@since 20130126
 *@version 20150920
 */
public class LinearTransform extends ColorTransform
{
	/** Slope of the transform.*/
	protected double slope=1d;
	/** Shift of the transform.*/
	protected double shift=0d;




	/** {@inheritDoc} */
	@Override
	public double transform(double c) {return slope*(c-shift);}
	/** {@inheritDoc} */
	@Override
	public double[] getBounds(){return new double[]{shift,1d/slope+shift};}



	/**Sets the slope.*/
	public void setSlope(double slope){this.slope=slope;}
	/**Sets the shift.*/
	public void setShift(double shift){this.shift=shift;}


	/** Sets tranform parameters so	that both ends of the color scale will represent negative and positive extrem. */
	public void setAbsoluteExtrem(double extrem){setBoundary(-extrem,extrem);}
	/**Sets transform so that minimum value will be represented by color at the begining
	 *and maximum value at the end of the color scale.*/
	public void setBoundary(double min,double max)
	{
		slope=1d/(max-min);
		shift=min;
	}




	// MAIN
	/** Main method. */
	public static void main(String[] arguments) throws Exception
	{
		LinearTransform transform=new LinearTransform();
		transform.setBoundary(-3,4);
		System.out.println(transform.transform(4));
	}




}
