
/*
 * KITNARF's Java Library <http://www.kitnarf.cz/java/>.
 * COPYRIGHT (C) 2009 Petr Frantík (www.kitnarf.cz). ALL RIGHTS RESERVED. 
 */


package cz.kitnarf.color;

import java.awt.*;


//**************************************************************************************************************************
/**
 *Superelliptic color function. This function is little deformed segment of
 *ellipse in RGB space. It has 1019 colors.
 *
 *@author Petr Frantík
 *@version 20130126
 */
public class SuperellipticColorFunction extends ColorFunction
{



	//*****************************************************************************************
	/** {@inheritDoc} */
	@Override
	public Color getColor(double cd)
	{
		int[] ci=new int[3];
		//
		//
		//uhel
		double ad=Math.PI*cd;
		double bd=0.5*Math.cos(ad);
		double corrd=0.12*(1-Math.cos(2*ad));
		//
		ci[0]=(int)((0.5+bd-corrd)*255.999999999999);
		ci[1]=(int)(Math.sin(ad)*255.999999999999);
		ci[2]=(int)((0.5-bd-corrd)*255.999999999999);
		//
		return new Color(ci[0],ci[1],ci[2]);
	}

}
