
/*
 * KITNARF's Java Library <http://www.kitnarf.cz/java/>.
 * COPYRIGHT (C) 2009 Petr Frantík (www.kitnarf.cz). ALL RIGHTS RESERVED. 
 */


package cz.kitnarf.color;

import java.awt.*;


//**************************************************************************************************************************
/**
 *Trilinear color function. This function is composed from three straight
 *segments. It has 766 colors.
 *
 *@author Petr Frantík
 *@version 20130126
 */
public class TrilinearColorFunction extends ColorFunction
{



	//*****************************************************************************************
	/** {@inheritDoc} */
	@Override
	public Color getColor(double cd)
	{
		int[] ci=new int[3];
		//
		//
		if(cd<=0.333333333333)
		{
			ci[0]=255;
			ci[1]=(int)(cd*766);
			ci[2]=0;
		}
		else if(cd<=0.666666666666)
		{
			ci[0]=(int)((0.6666666666-cd)*766+0.333333333333);
			ci[1]=255;
			ci[2]=255-ci[0];
		}
		else
		{
			ci[0]=0;
			ci[1]=(int)((1.0-cd)*766);
			ci[2]=255;
		}
		//
		return new Color(ci[0],ci[1],ci[2]);
	}

}
